"use strict";var assert=require("./assert"),der=require("./der"),messages=require("./messages.json");function initCompressedValue(e,s){return void 0===e?s:(assert.isBoolean(e,messages.COMPRESSED_TYPE_INVALID),e)}module.exports=function(t){return{privateKeyVerify:function(e){return assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),32===e.length&&t.privateKeyVerify(e)},privateKeyExport:function(e,s){assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(e,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),s=initCompressedValue(s,!0);var r=t.privateKeyExport(e,s);return der.privateKeyExport(e,r,s)},privateKeyImport:function(e){if(assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),(e=der.privateKeyImport(e))&&32===e.length&&t.privateKeyVerify(e))return e;throw new Error(messages.EC_PRIVATE_KEY_IMPORT_DER_FAIL)},privateKeyNegate:function(e){return assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(e,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),t.privateKeyNegate(e)},privateKeyModInverse:function(e){return assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(e,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),t.privateKeyModInverse(e)},privateKeyTweakAdd:function(e,s){return assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(e,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),assert.isBuffer(s,messages.TWEAK_TYPE_INVALID),assert.isBufferLength(s,32,messages.TWEAK_LENGTH_INVALID),t.privateKeyTweakAdd(e,s)},privateKeyTweakMul:function(e,s){return assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(e,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),assert.isBuffer(s,messages.TWEAK_TYPE_INVALID),assert.isBufferLength(s,32,messages.TWEAK_LENGTH_INVALID),t.privateKeyTweakMul(e,s)},publicKeyCreate:function(e,s){return assert.isBuffer(e,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(e,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),s=initCompressedValue(s,!0),t.publicKeyCreate(e,s)},publicKeyConvert:function(e,s){return assert.isBuffer(e,messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(e,33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID),s=initCompressedValue(s,!0),t.publicKeyConvert(e,s)},publicKeyVerify:function(e){return assert.isBuffer(e,messages.EC_PUBLIC_KEY_TYPE_INVALID),t.publicKeyVerify(e)},publicKeyTweakAdd:function(e,s,r){return assert.isBuffer(e,messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(e,33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID),assert.isBuffer(s,messages.TWEAK_TYPE_INVALID),assert.isBufferLength(s,32,messages.TWEAK_LENGTH_INVALID),r=initCompressedValue(r,!0),t.publicKeyTweakAdd(e,s,r)},publicKeyTweakMul:function(e,s,r){return assert.isBuffer(e,messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(e,33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID),assert.isBuffer(s,messages.TWEAK_TYPE_INVALID),assert.isBufferLength(s,32,messages.TWEAK_LENGTH_INVALID),r=initCompressedValue(r,!0),t.publicKeyTweakMul(e,s,r)},publicKeyCombine:function(e,s){assert.isArray(e,messages.EC_PUBLIC_KEYS_TYPE_INVALID),assert.isLengthGTZero(e,messages.EC_PUBLIC_KEYS_LENGTH_INVALID);for(var r=0;r<e.length;++r)assert.isBuffer(e[r],messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(e[r],33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID);return s=initCompressedValue(s,!0),t.publicKeyCombine(e,s)},signatureNormalize:function(e){return assert.isBuffer(e,messages.ECDSA_SIGNATURE_TYPE_INVALID),assert.isBufferLength(e,64,messages.ECDSA_SIGNATURE_LENGTH_INVALID),t.signatureNormalize(e)},signatureExport:function(e){assert.isBuffer(e,messages.ECDSA_SIGNATURE_TYPE_INVALID),assert.isBufferLength(e,64,messages.ECDSA_SIGNATURE_LENGTH_INVALID);var s=t.signatureExport(e);return der.signatureExport(s)},signatureImport:function(e){assert.isBuffer(e,messages.ECDSA_SIGNATURE_TYPE_INVALID),assert.isLengthGTZero(e,messages.ECDSA_SIGNATURE_LENGTH_INVALID);var s=der.signatureImport(e);if(s)return t.signatureImport(s);throw new Error(messages.ECDSA_SIGNATURE_PARSE_DER_FAIL)},signatureImportLax:function(e){assert.isBuffer(e,messages.ECDSA_SIGNATURE_TYPE_INVALID),assert.isLengthGTZero(e,messages.ECDSA_SIGNATURE_LENGTH_INVALID);var s=der.signatureImportLax(e);if(s)return t.signatureImport(s);throw new Error(messages.ECDSA_SIGNATURE_PARSE_DER_FAIL)},sign:function(e,s,r){assert.isBuffer(e,messages.MSG32_TYPE_INVALID),assert.isBufferLength(e,32,messages.MSG32_LENGTH_INVALID),assert.isBuffer(s,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(s,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID);var _=null,E=null;return void 0!==r&&(assert.isObject(r,messages.OPTIONS_TYPE_INVALID),void 0!==r.data&&(assert.isBuffer(r.data,messages.OPTIONS_DATA_TYPE_INVALID),assert.isBufferLength(r.data,32,messages.OPTIONS_DATA_LENGTH_INVALID),_=r.data),void 0!==r.noncefn&&(assert.isFunction(r.noncefn,messages.OPTIONS_NONCEFN_TYPE_INVALID),E=r.noncefn)),t.sign(e,s,E,_)},verify:function(e,s,r){return assert.isBuffer(e,messages.MSG32_TYPE_INVALID),assert.isBufferLength(e,32,messages.MSG32_LENGTH_INVALID),assert.isBuffer(s,messages.ECDSA_SIGNATURE_TYPE_INVALID),assert.isBufferLength(s,64,messages.ECDSA_SIGNATURE_LENGTH_INVALID),assert.isBuffer(r,messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(r,33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID),t.verify(e,s,r)},recover:function(e,s,r,_){return assert.isBuffer(e,messages.MSG32_TYPE_INVALID),assert.isBufferLength(e,32,messages.MSG32_LENGTH_INVALID),assert.isBuffer(s,messages.ECDSA_SIGNATURE_TYPE_INVALID),assert.isBufferLength(s,64,messages.ECDSA_SIGNATURE_LENGTH_INVALID),assert.isNumber(r,messages.RECOVERY_ID_TYPE_INVALID),assert.isNumberInInterval(r,-1,4,messages.RECOVERY_ID_VALUE_INVALID),_=initCompressedValue(_,!0),t.recover(e,s,r,_)},ecdh:function(e,s){return assert.isBuffer(e,messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(e,33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID),assert.isBuffer(s,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(s,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),t.ecdh(e,s)},ecdhUnsafe:function(e,s,r){return assert.isBuffer(e,messages.EC_PUBLIC_KEY_TYPE_INVALID),assert.isBufferLength2(e,33,65,messages.EC_PUBLIC_KEY_LENGTH_INVALID),assert.isBuffer(s,messages.EC_PRIVATE_KEY_TYPE_INVALID),assert.isBufferLength(s,32,messages.EC_PRIVATE_KEY_LENGTH_INVALID),r=initCompressedValue(r,!0),t.ecdhUnsafe(e,s,r)}}};